/**
 * Shibuya CMS 管理画面用JSファイル
 * 自由に編集して頂いて構いません
 */
jQuery(function($){

	var ADMIN_URL = location.href.match(/^(.*\/wp\-admin\/)/) ? RegExp.$1 : '/wp-admin/';
	
	/**
	 * メディアアップローダーの設定
	 * Media Uploader for WP version above 3.5
	 */
	if( wp.media ){
		var shibuyaCmsUpload = function(e){
			e.preventDefault();
			
			var target = $(this).data( 'uploader-target' );
			if( !target ) {
				alert( 'Please set \'data-uploader-target\' for button.' );
				return;
			}
			
			var uploader = wp.media({
				title: $(this).data( 'uploader-title' ) || 'Media Uplader',
				button: {
					text: $(this).data( 'uploader-button-text' ) || 'Select File'
				},
				multiple: $(this).data( 'uploader-multiple' ) || false
			});
			
			uploader.on( 'select', function() {
				var attachment = uploader.state().get('selection').first().toJSON();
				$(target).val( attachment.id ).trigger('change');
			});
			
			uploader.open();
		};
		
		var shibuyaCmsFileChange = function(){
			var id = $(this).val(),
			         $parents = $(this).parents('.image-box,.file-box');
			$.getJSON( ADMIN_URL + '?shibuya-cms-attachment.php', {'id':id}, function(file){
				if( $parents.filter('.image-box').length ) {
					$parents.find('img').attr( 'src', file.thumb_url );
				} else if( $parents.filter('.file-box').length ) {
					$parents.find('a.shibuya-cms-file').attr( 'href', file.url ).html(file.name);
				}
			});
		};
		
		var shibuyaCmsEmptyInput = function(e){
			e.preventDefault();
			e.stopPropagation();
			$(this).parents('.image-box,.file-box').find('input').val('').trigger('change');
		};
		
		//アップローダーのコールバックの設定
		if( $().on ){
			$(document).on( 'click', '.uploader', shibuyaCmsUpload );
			$(document).on( 'change', '.image-box input,.file-box input', shibuyaCmsFileChange );
			$(document).on( 'click', '.image-box .remove,.file-box .remove', shibuyaCmsEmptyInput );
		} else if( $().live ){
			$('.uploader').live( 'click', shibuyaCmsUpload );
			$('.image-box input').live( 'change', shibuyaCmsFileChange );
			$('.image-box .remove,.file-box .remove').live( 'click', shibuyaCmsEmptyInput );
		}
	}
	
	//チェックボックスやラジオボタンの変更のコールバック
	var shibuyaCmsCheckChangeCallback = function(){
		var name = $(this).attr('name');
		if( name ){
			$('input[name="'+name+'"]').each(function(){
				if( $(this).attr('checked') ){
					$(this).parents('.radio,.checkbox').eq(0).addClass('selected');
				} else {
					$(this).parents('.radio,.checkbox').eq(0).removeClass('selected');
				}
			});
		}
	};
	
	if( $().on ){
		$(document).on( 'change', '.radio input,.checkbox input', shibuyaCmsCheckChangeCallback);
	} else if( $().live ){
		$('.radio input,.checkbox input').live( 'change', shibuyaCmsCheckChangeCallback);
	}
	
	
	//カスタムフィールドデータの呼び出し
	if( shibuyaCmsCustomFields ){
		$('*[name^="@"]').each(function(){
			var tagName = this.tagName.toLowerCase(),
			    name    = $(this).attr('name').replace(/^@/, '');
			
			var type = tagName == 'input'
							? $(this).attr('type').toLowerCase()
							: tagName;
			
			var target = name.replace(/^([^\[]+)/, function(matched){ return "['"+matched+"']" })
											.replace(/\[\]$/, '');
			
			var value = eval( 'shibuyaCmsCustomFields' + target );
			
			if( ! value )
				return;
			
			switch( type ) {
				case 'radio':
				case 'checkbox':
					if( ( $.isArray( value ) && $.inArray( $(this).val(), value ) > -1 )
												|| $(this).val() == value )
						$(this).prop( 'checked', true );
					break;
				default:
					if( type == 'hidden' && $(this).val() !== '' )
						break;
					if( ! $.isArray( value ) ) {
						$(this).val( value );
					} else {
						if( name.match(/\[(.*?)\]/) ){
							var key = RegExp.$1;
							if( value[ key ] )
								$(this).val( value[ key ] );
						} else {
							if( value[0] )
								$(this).val( value[0] );
						}
					}
			}
			if( !$(this).parents('.image-box').length )
				$(this).trigger('change');
		});
		
		var ids = [];
		$('.image-box input:hidden,.file-box input:hidden').each(function(){
			if( $(this).val() )
				ids.push( $(this).val() );
		});
		$.getJSON(ADMIN_URL + '?shibuya-cms-attachment.php', {'ids': ids.join(',')}, function(json){
			$.each(json, function(id, file) {
				var $target = $('.image-box input:hidden,.file-box input:hidden').filter('input[value="'+ file.id +'"]');
				if( $target.length ) {
					$parents = $target.parents('.image-box,.file-box');
					if( $parents.filter('.image-box').length ) {
						$parents.find('img').attr( 'src', file.thumb_url );
					} else if( $parents.filter('.file-box').length ) {
						$parents.find('a.shibuya-cms-file').attr( 'href', file.url ).html(file.name);
					}
				}
			});
		});
	}
	
	
	//日付選択
	$('.datepicker').datepicker({ dateFormat:'yy-mm-dd' });
	//$('.sortable').sortable();
	
	$('.image-sortable').sortable({
		update: function( event, ui ) {
			$('.image-sortable .image-box').each(function(i){
				var name = '@image['+ i +']';
				$('input[name^="@image"]', this).attr('name', name);
				$('button[data-uploader-target]', this).attr('data-uploader-target', 'input[name="'+ name +'"]');
			});
		}
	});
	
});